"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ApiError extends Error {
    constructor() {
        super(...arguments);
        this.status = 200;
        this.message = '200 OK';
        this.description = 'No description available';
    }
}
exports.ApiError = ApiError;
class InvalidCredentialsError extends ApiError {
    constructor() {
        super();
        this.status = 301;
        this.message = 'Invalid Credentials';
        this.description = '';
    }
}
exports.InvalidCredentialsError = InvalidCredentialsError;
class NotAuthorizedError extends ApiError {
    constructor() {
        super();
        this.status = 403;
        this.message = 'Not authorized';
        this.description = 'You are not authorized for this action';
    }
}
exports.NotAuthorizedError = NotAuthorizedError;
class ResourceNotFoundError extends ApiError {
    constructor() {
        super();
        this.status = 404;
        this.message = 'Resource not found';
        this.description = 'Requested resource not found';
    }
}
exports.ResourceNotFoundError = ResourceNotFoundError;
class MissingParameterError extends ApiError {
    constructor() {
        super();
        this.status = 409;
        this.message = 'Missing parameter';
        this.description = 'Something went wrong! Check your request parameters and try again';
    }
}
exports.MissingParameterError = MissingParameterError;
class InternalError extends ApiError {
    constructor() {
        super();
        this.status = 500;
        this.message = 'Internal Server Error';
        this.description = 'Something went wrong on our side!';
    }
}
exports.InternalError = InternalError;
