export class ApiError extends Error {
    public status: number = 200;
    public message = '200 OK';
    public description = 'No description available';
}

export class InvalidCredentialsError extends ApiError {
    constructor() {
        super();

        this.status = 301;
        this.message = 'Invalid Credentials';
        this.description = '';
    }
}

export class NotAuthorizedError extends ApiError {
    constructor() {
        super();

        this.status = 403;
        this.message = 'Not authorized';
        this.description = 'You are not authorized for this action';
    }
}

export class ResourceNotFoundError extends ApiError {
    constructor() {
        super();

        this.status = 404;
        this.message = 'Resource not found';
        this.description = 'Requested resource not found';
    }
}
export class MissingParameterError extends ApiError {
    constructor() {
        super();

        this.status = 409;
        this.message = 'Missing parameter';
        this.description = 'Something went wrong! Check your request parameters and try again';
    }
}
export class InternalError extends ApiError {
    constructor() {
        super();

        this.status = 500;
        this.message = 'Internal Server Error';
        this.description = 'Something went wrong on our side!';
    }
}