import { Request, Response } from './types';
import { IncomingForm } from 'formidable';

export function bodyParser(request: Request, response: Response, next) {

    if (request.method !== 'POST') return next();

    let form = new IncomingForm();
    form.maxFields = 500;
    form.maxFieldsSize = 2 * 1024 * 1024;

    form.parse(request, (err, fields) => {
        if(err) throw err;

        request.body = fields;
        next();
    });
}